//Incluimos librerias

#include "C:\Users\Daybi\PROYECTO\Conversor_DigitalAnalogico\Conv DA.h"
#include "Math.h"

//Declaracin e inicializacin de variables globales que utilizaremos
// a lo largo del programa de control

short signo;
long int aux,aux2,aux3,aux4=0;

long int usen;

float uref=2.5;      //Altura deseada por el usuario
float ek;
float uk;
float uk_1=0;       //Se guardara el valor de tension anterior
float ek_1=0;
float ek_2=0;
float usenf;


float kp=0.175;                        
float ki=0.00010;    
float kd=0.0003;     

//Metodo principal (main)

void main(int argc,char *argv[]){

output_c(0x00);               //Salidas a cero para evitar posibles estados
output_d(0x00);               // inciales anmalos
//------------------------------------------------------------------------------
   disable_interrupts(GLOBAL);       //todas las interrupciones desactivadas
   
   setup_adc_ports(NO_ANALOGS);
   setup_adc(ADC_OFF);
   setup_psp(PSP_DISABLED);
   setup_spi(FALSE);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   
//------------------------------------------------------------------------------

// Configuracin de los puertos como entrada o salida

   set_tris_a(0xFF);                 //portA como entrada
   set_tris_b(0xFF);                 //portB como entrada
   set_tris_c(0x00);                 //portC como salida
   set_tris_d(0x00);                 //portD como salida
   set_tris_e(0b00000010);           //portE RE1 entrada, RE2 salida
   
   //                             ______________
   //                            |              |
   //           PORT A -->       |              |  --> PORT C
   //                            |      PIC     |
   //           PORT B -->       |    16F877    |  --> PORT D
   //                            |              |
   //           RE1 (PORT E) --> |              |  --> RE2 ( PORT E )
   //                            |______________|
   

//--------------------------- Programa PID -------------------------------------

delay_ms(2500);           // Retardo para la estabilizacin de la tensin 
                         // de 2.5 segundos

while (TRUE){            

output_low(PIN_E2);      //Se activa la conversion de Analgico a Digital 

aux=input_b();           //Se guarda en aux lo que recibimos del ADC


aux2=input_a();         //Se guarda en aux2 lo qe recibimos del ADC
aux2=aux2<<8;

usen=aux+aux2;          // Se suman ambos valores para tener el resultado 
                        // convertido a digital (12 bits)

usenf=(float)usen;      //Se hace un casting a float para poder trabajar con el 
                       // comodamente


usenf=usenf*0.00122;


output_high(PIN_E2);  //Se vuelve a poner el RE2 a nivel alto para poder ponerlo
                      // posteriormente a nivel alto para una nueva reiteracion


ek= usenf-uref;       //Se calcula el error de posicion de la bola


   uk=uk_1+kd*ek_2-(kp+2*kd)*ek_1+(kp+ki+kd)*ek; //Ecuacin del PID digital

 ek_2=ek_1;        //El error 2 veces anterior pasa a ser el anterior
 ek_1=ek;          //El error anterior ahora pasa a ser el actual

// Por precaucion el voltaje de salida no puede ser mayor que 5 V asi que 
// lo tenemos en cuenta

if(uk>5){  
           uk=5;
           uk_1=uk;
           
        }//Fin del if
else{
     uk_1=uk;
     
     }//Fin del else

//De la misma manera el voltaje de salida no puede ser menor que 0 al estar en
//lgica positiva

if(uk<0){
         signo=1;    
         
         }//Fin del if
else{
     signo=0;
     
     }//Fin del else

if(signo==1){                 //La tension es negativa
               uk_1=-uk;
               uk=abs(uk);   //Ponemos la salida a positivo
             
             }//Fin del if
else{
         uk_1=uk;
     }

// ------ PASO DE DIGITAL A ANALOGICO --------------------------------------
   
   uk=uk/0.00122;      //Al igual que antes multiplicamos la entrada por la
                       // constante a la salida dividimos por esa misma 
                       // constante para tener el valor de salida controlado 
                       // entre 0 y 5 V
                       
   if(uk>4095) uk=4095;  //Si fuera mayor a 4095 
   uk=ceil(uk);
   aux3=(long)uk;
                                     // Operacion and para sacar los 8 MSB
   aux4=aux3&4080;                  // 4080= b'0000111111110000';
   output_c(aux3&15);               // Se sacan los 4 LSB
   output_d(aux4>>4);               // Se sacan los 8 MSB

                     //Se muestra en la salida los 12 bits que trasladamos a 
                     // la entrada del DAC a traves de las puertas C y D

}                    // Fin while
}                    // Fin main



